LRU Cache - Twitch Interview Question - Leetcode 146

  Рет қаралды 324,078

NeetCode

NeetCode

Күн бұрын

Пікірлер: 285
@NeetCode
@NeetCode 2 жыл бұрын
LFU Cache: kzbin.info/www/bejne/mH2oenukYqmapaM 🚀 neetcode.io/ - I created a FREE site to make interview prep a lot easier, hope it helps! ❤
@RMarcus05
@RMarcus05 3 жыл бұрын
Watched so many of your videos prepping for an SDE 1 FAANG interview. I was asked this exact question (OO LRU Cache) and also Walls and Gates (which you have a video on). I managed to remember/and work through the problems incredibly easy b/c I could vividly remember your explanations and drawings. Happily, I received an offer today! Can’t thank you enough :)
@NeetCode
@NeetCode 3 жыл бұрын
That's awesome Ryan, you just made my day! Congrats 🎉
@shauryakapoor2122
@shauryakapoor2122 2 жыл бұрын
what company? CONGRATSSS!!!!!!!!!
@anonymoustv8604
@anonymoustv8604 2 жыл бұрын
That's so cool man. Congrats!!
@boscodomingo
@boscodomingo 2 жыл бұрын
Aaaaaaand that is the perfect example of how broken these interview questions are. I'm glad you got it, but you didn't necessarily work it out yourself. You were lucky enough to be asked a question you already knew the answer to. This rarely ever happens in real life! And when it does, all you have to do is use a method from a library 99% of the times. You need problem solving skills these interviews don't ask for, and I hate it. Glad you got to game the system, and best of luck when facing actual programming problems!
@minciNashu
@minciNashu 2 жыл бұрын
@@boscodomingo on the other hand, this evens out the playfield
@zishiwu7757
@zishiwu7757 2 жыл бұрын
Thanks! I have an interview tomorrow. Been preparing by watching your videos on the Blind 75 and Neetcode 150 questions. Really appreciate the time you take in making these videos and giving clear explanations. Hope you can keep it up.
@NeetCode
@NeetCode 2 жыл бұрын
Thank you so much!! And best of luck!!
@shavitl.306
@shavitl.306 2 жыл бұрын
Hi, I'm doing this too! so thanks too, NeetCode. How did it go @Zishi Wu? are you happy about this way of preparation? any suggestions?
@shadyplaysgoodgames
@shadyplaysgoodgames Жыл бұрын
how did ur interview go?
@zishiwu7757
@zishiwu7757 Жыл бұрын
​@@shadyplaysgoodgames Interview went well and I got the job. I've been working 6 months so far and really like. Now I'm hoping not to be impacted by layoffs in tech industry.
@JRK_RIDES
@JRK_RIDES Жыл бұрын
​@@zishiwu7757 I know I'm late but really happy to see someone succeed. Thank you for sharing your experience.
@TannerBarcelos
@TannerBarcelos Жыл бұрын
Been deep into my work in my current job and have gone completely rusty on algorithms / data structures. Hell, I was never good to begin with but just worked hard enough to land my gig. Starting to look into a fresh start at a new company, so getting back to the Leetcode - algorithms grind, and came across your channel again. This was an awesome solution but also a very helpful, straightforward explanation of the problem, data structures to use, solution, and everything in between. Thanks a ton.
@TehCourier
@TehCourier Жыл бұрын
I think this is one of the most insane questions I've ever tried lol
@bronchiel
@bronchiel Жыл бұрын
a way i thought of solving this problem was with a queue and a hashmap, but i soon realized that there was no way to do such a thing in O(1) since finding an element would require me to go through the entire queue in worst case, and that having a map would be entirely useless in this case… so, i appreciate the solution you’ve brought here for us
@ShiftK
@ShiftK Жыл бұрын
This was exactly my train of thought as well! Using a LinkedList for keeping track of the LRU and of the "most used" is better than a queue since we can store the Nodes directly into the HashMap. Therefore, when we access this node, we already have its next() and right() siblings to make the Get and Put function O(1)
@ChanChan-pg4wu
@ChanChan-pg4wu 2 жыл бұрын
This has been a dreadful question that I did not want to touch until today. Thank you, Neet for the clear explanation! You will make a hell of an instructor!
@CST1992
@CST1992 8 ай бұрын
He's already a hell of an instructor.
@FasTical
@FasTical 2 жыл бұрын
It took me 1 night to figure out the traversal node between insert and remove, it's hard to imagine without doing any drawing, and I glad that I'm able to figure it out :) You're truly a legend to be able to figure this.
@aaditya_87
@aaditya_87 9 ай бұрын
lmao neetcode used to put music at the start of videos
@BrennenSongyongYu
@BrennenSongyongYu 2 ай бұрын
I'm gonna make it habit to say thank you on every LeetCode video I watch of yours. I remember your recent LinkedIn post where you talked about how you enjoy doing these, but they don't bring as much views as your other content. Just want to show that your work is meaningful!
@brucebatmanwayne8514
@brucebatmanwayne8514 2 жыл бұрын
1:33 love how he drew the chrome logo completely to explain about the browser😂
@puzzle-headed-cat
@puzzle-headed-cat 2 ай бұрын
was thinking the same, the logo was pretty good ngl
@Wes-Tyler
@Wes-Tyler 3 жыл бұрын
This was explained so well, and I massively appreciate that you talked slowly because that was a ton to take in all at once
@CST1992
@CST1992 8 ай бұрын
That is the only reason that I keep coming back to this channel - he talks at a reasonable pace unlike some other channels that go on and on like a machinegun.
@stormarrow2120
@stormarrow2120 3 жыл бұрын
I stopped the video at 5:20 and was able to solve the rest on my own. Thanks for making this video. Great explaination.
@tesuji-go
@tesuji-go 4 ай бұрын
I implemented LRU for an in-process cache a couple years ago and both Java and Javascript have a Map variant that returns the keys in insertion order. They already have the linked list built in between the nodes, you don't need to make a second one. What Javascript doesn't do is update the key order on overwrite, so you have to delete and add every time. But it saves a ton of code.
@prafulparashar9849
@prafulparashar9849 2 жыл бұрын
I was asked this question just today in a system design round and absolutely and horribly tanked it big time. Regretting why I did not see this before but also happy that I got to see this solution. This is engraved in my brain now !! Thanks for the good work ✅
@mama1990ish
@mama1990ish 3 жыл бұрын
This channel is much better to the point and easy to understand then others.
@strawberriesandcream2863
@strawberriesandcream2863 Жыл бұрын
never would have thought to use a doubly linked list🤦‍♀thanks for the explanation!!
@maria_sitkovets_tech
@maria_sitkovets_tech 4 жыл бұрын
Your explanation was so good! I'm gonna watch more of your videos now
@thelonearchitect
@thelonearchitect 2 жыл бұрын
It took me a good two hours to understand why we should have a map to Node and not a map to Value but now it just makes so much sense. Algorithms really has a way to enlarge the mind.
@haibangi
@haibangi Жыл бұрын
tough problem.. it was hard LC before I think maybe would've been better to take a case where capacity is like 4 or 5, problem is already confusing with left/right pointers and prev/next variables but overall great video, thanks
@jxw7196
@jxw7196 4 жыл бұрын
Hey man your videos are great! Keep up the good work - it looks like you have taken your time to plan your videos carefully too.
@NeetCode
@NeetCode 4 жыл бұрын
Thanks! I'm happy they are helpful!
@VenomIsLazy
@VenomIsLazy 6 ай бұрын
Best Channel I ever seen for any DSA problem thank you so much even if I don't get placed in any company still learned alot.
@linchen4535
@linchen4535 3 жыл бұрын
I would give you X100 thumbs up if I could! Clear explanation and makes me fully understand why using those data structures and design a class!!
@NeetCode
@NeetCode 3 жыл бұрын
Happy to help 😊
@Sulerhy
@Sulerhy 10 ай бұрын
I need more than 1 hour to understand your brilliant idea. GOD!
@Artemius10
@Artemius10 Жыл бұрын
Awesome, thx! It amazes me how clear and easy it gets after explanation, yet how complicated it seems (and actually is) when you have to solve this in a stressful limited time environment like in an interview. One note though - in case if key is already present in cache in insert function, before inserting node itself, we should return before doing len(cache) > capacity check, this way we get quite a significant optimization by not doing redundant heavy logic. Another note would be to add a current count property to LRUCache to not execute len(cache) at all and reduce time complexity from O(n) to O(1).
@sumeshbharathiramasamy8559
@sumeshbharathiramasamy8559 Жыл бұрын
Hi @Artemius10, I think both your proposals are invalid. 1. the second "if' loop (capacity check) will be true only if new insert is going to happen. Calling "return" before it, won't significantly improve performance, i believe. 2. len(HashMap) will be always O(1). Because in Python, Hashmaps will always keep track of their sizes, so iterations will not be performed for length.
@potaot573
@potaot573 2 жыл бұрын
Thanks Mr. NeetCode. I got LRU Cache on my last interview and got the offer.
@nikhildinesan5259
@nikhildinesan5259 4 жыл бұрын
Thnxx bruv...your videos are just awesome... keep it coming
@NeetCode
@NeetCode 4 жыл бұрын
Glad you like them!
@crit19871
@crit19871 3 жыл бұрын
Thanks
@NeetCode
@NeetCode 3 жыл бұрын
Thank you so much!!!
@anangelsdiaries
@anangelsdiaries 5 ай бұрын
I was so close yet so far, thank you for this!
@TSS554
@TSS554 11 ай бұрын
You're awesome dude, thanks for all the work you do to help us out
@niko-l-
@niko-l- 4 жыл бұрын
Omg. I found you today and am watching toy all evening I can't stop
@navaneeth67
@navaneeth67 4 күн бұрын
The rare occasion where the coding part is longer than the drawing part in a NeetCode video
@abhayattri974
@abhayattri974 5 ай бұрын
try using ordered dict for the implementation, will make the code whole lot easier. when getting if key is found move_to_end(key) else -1 when putting - add key then move_to_end(key) and if len(dict) > cap: pop(last= false)
@PJ-hi1gz
@PJ-hi1gz 5 ай бұрын
thanks so much.
@QuadQuadQuadQuad
@QuadQuadQuadQuad 4 жыл бұрын
Nice explanation and diagramming! Keep them coming
@AustinCS
@AustinCS 4 ай бұрын
I think it would be helpful to consider different naming conventions for left and right - essentially because they are sentinel nodes that basically reference the head and tail of the doubly linked list.
@codeunited5905
@codeunited5905 Жыл бұрын
I attempted to make an LRU cache on my own without watching the video in Go. I come up with a more naive and slow version which takes advantage to slices and map in Go. But I'll definitely try to rewrite the code using LL and map. It was really fun!
@watchlistsclips3196
@watchlistsclips3196 3 жыл бұрын
Neetcode you are amazing i saw many people are using doubly linked list but not linked list but i am not getting why we should use doubly linked lists i saw videos from top 3 of my youtube channels but they didn't explain the clear intuition behind taking doubly linked lists.I am scratching head why doubly linked lists for 1 hour. Now i got reason😌😌.Thank you
@brentjackson6966
@brentjackson6966 2 жыл бұрын
This is a badly described coding problem. For one thing, it does not describe a LRU or a MRU. It describes a FIFO queue - the first entry added will be the first evicted. The second added will be the second evicted. etc. To answer your question. Imagine a MRU - like the 'recent files' in VS Code. When you open a file it gets added to the front of the 'recent files' list and if the list is 'full' (at capacity) the oldest gets removed from the end of the 'recent files' list. If you open the 7th file in the 'recent files' it is moved from the 7th spot to the start of the list. To do this, you can find the linked list entry using the hash map but for a single linked list you would now need to walk the linked list from the start to find the 6th entry so you can link it to the 8th, thus removing the 7th from the list so you can put it at the start. Walking the linked list is an O(list-size) operation. If you have a double linked list, each node has a pointer to the previous and next next node so you can remove the 7th in O(1) time. And the puzzle mentions doing 'put' and 'get' in O(1) time. That's why people use a double linked list for this problem. However, since the problem does not involve moving entries from the middle to the front of the list, there is no reason to use a double linked list.
@nikhil_a01
@nikhil_a01 2 жыл бұрын
@@brentjackson6966 It's not correct that it's a FIFO queue. The first entry added is not always the first one evicted, because any `get()` or `put()` on an existing key counts as a use. The linked list is maintained in access order, not insertion order. Simple example: The cache's capacity is 3 and I add keys 1, 2, and 3. Then I read key 1 which counts as a use. When I add key 4, key 2 will be evicted even though key 1 was the first one added. And it does move entries from the middle to the end of the list, which is why it's doubly linked. Every use (get or update) removes the node with that key and puts it at the end.
@dheepthaaanand3214
@dheepthaaanand3214 Ай бұрын
Just want to point out that get() reuses the same node pointer, but in put (), if the node exists, we are de-linking the existing node pointer, creating a new node pointer and linking that, but we aren't clearing the memory of the old node pointer, i.e, using del function like how we did for deleting the LRU node if capacity exceeds, so i think we should add that extra line
@saurabh2802
@saurabh2802 4 ай бұрын
i have never felt so fucking dumb in my life, this is so fucking hard man
@AhmedMarzookisabeast
@AhmedMarzookisabeast 3 ай бұрын
thanks for the explnation main part i got stuck on was thinking of using a queue but a doubly linked list makes sense should have checked the topics section in LeetCode for some clues here is my solutions got a 169ms runtime but didn't use dummy nodes and had to cover the null scenarios: class NodeItem: def __init__(self,key, val): self.key = key self.val = val self.next = None self.prev = None class LRUCache: def __init__(self, capacity: int): self.capacity = capacity self.cache = {} self.head = None self.tail = None def get(self, key: int) -> int: if key in self.cache: node = self.cache[key] self.remove_node(node) self.add_to_mru(node) return node.val else: return -1 def put(self, key: int, value: int) -> None: new_node = NodeItem(key, value) if key in self.cache: self.remove_node(self.cache[key]) self.cache[key] = new_node self.add_to_mru(new_node) return if len(self.cache) >= self.capacity: del self.cache[self.head.key] self.remove_node(self.head) val = self.cache[key] = new_node self.add_to_mru(val) def add_to_mru(self, value: NodeItem): if self.head == None and self.tail == None: self.head = value self.tail = value else: self.tail.next = value value.prev = self.tail self.tail = value def remove_node(self, node: NodeItem): if node == self.head: self.head = node.next if self.head: self.head.prev = None else: node.prev.next = node.next if node == self.tail: self.tail = node.prev if self.tail: self.tail.next = None else: node.next.prev = node.prev if self.head is None: self.tail = None
@akhma102
@akhma102 5 ай бұрын
Thank you Neet! Learnt something new today!
@sy_alty
@sy_alty Жыл бұрын
The fact that this is now a MEDIUM difficulty question 💀 Seems like companies' hiring standards have gone up...
@ares9335
@ares9335 Ай бұрын
What was it originally? Hard?
@harshnegi5811
@harshnegi5811 Ай бұрын
@@ares9335 yes it was marked hard in leetcode, since a lot of companies are asking this nowadays.. its marked medium now
@dawitz362
@dawitz362 Ай бұрын
Nice explanation. Thanks NeetCode.
@vyomdavep18
@vyomdavep18 3 жыл бұрын
Great videos! Please keep up the good work!
@NightDay1
@NightDay1 10 күн бұрын
I think I reached my brain limit. I withdraw
@SomethingNick
@SomethingNick 2 жыл бұрын
I got asked a version of this for Bloomberg yesterday, wish I'd seen this video beforehand 😥
@symbol767
@symbol767 2 жыл бұрын
This is an incredible explainable, thank you!
@quirkyquester
@quirkyquester 7 ай бұрын
this solution is so elegant! Thank you!
@DelShott
@DelShott 2 жыл бұрын
Thanks man! I am scared of this type of "Medium" questions. I would certainly freeze during an interview...
@sijunchen7270
@sijunchen7270 3 жыл бұрын
Thank you so much, it saved my day of struggling it using python
@shantipriya370
@shantipriya370 6 ай бұрын
this solution is the best i've come across.. thank you..
@sachleenkaur8731
@sachleenkaur8731 20 күн бұрын
why do we initialise lru = self.left.next and not lru = self.left at 13:54
@racecarjonny8460
@racecarjonny8460 4 ай бұрын
Among all the neetcode videos I have watched, this one takes longer to code the solution than drawing the explanation.
@ritwik_shivam
@ritwik_shivam 2 жыл бұрын
Amazing explanation as always, just a doubt 6:35, why are we removing [2,2] instead of [1,1] since it was leftmost and least recently used, shouldn't that be [2,2], [3,3] after re-arranging the cache.
@amandaflood
@amandaflood 2 жыл бұрын
1 was asked for by 'get' so counts as most recently used. I was confused by this too to start with.
@anabelberumen
@anabelberumen 2 жыл бұрын
I love you boy!!! you made me understand many things
@MP-ny3ep
@MP-ny3ep 2 жыл бұрын
AWESOME EXPLANATION. THANK YOU !!!
@25kirtan
@25kirtan 2 жыл бұрын
beautiful. great code and implementation.
@g7parsh
@g7parsh 2 жыл бұрын
Hey man, i've been watching a ton of your videos lately in order to learn about data structures and problem solving and it's been really good stuff. A question i have though is how do you know what types of structures would be best fit for a given problem? What about a question makes you notice that you should use a hash map or a DLL or a stack? Or is that something that just comes about from just drawing out how an algorithm plays out?
@biskitpagla
@biskitpagla 2 жыл бұрын
Most problems don't require you to use any particular data structure. This one is different tho. It's the O(1) insertion and lookup that implies a hash map. There many are other data structures that offer similar performance, but for 80% of all problems you don't actually have to stray further than the same old five or more data structures. The DLL part is a bit hard to grasp for newbies like us but long story short, DLLs play nicely with hash maps, more so than others.
@s8x.
@s8x. Жыл бұрын
no way people can solve this for the first time without preparing for it
@dmytrodieiev9338
@dmytrodieiev9338 Жыл бұрын
solved it using c++ without preparation, the hint was on the LT under "topics": "hash map", "DLL" - then figured out the solution, which was pretty the same as showed here
@angeldiaz3018
@angeldiaz3018 7 ай бұрын
@@dmytrodieiev9338 then you're a robot or a special human
@vteckickedin2365
@vteckickedin2365 4 ай бұрын
@@dmytrodieiev9338 yep I was able to get it first time, but only because they mentioned the topics. Implementation was a nightmare though lol
@syedzami-ul-haquenavid9392
@syedzami-ul-haquenavid9392 2 жыл бұрын
Amazing explanation man!
@devanshimittal7986
@devanshimittal7986 3 ай бұрын
Hi Neetcode, we can use deque . i think it would provide more optimized solution. what do you think?
@k0tyak1t15
@k0tyak1t15 3 ай бұрын
It don't works in the case you put a new value into existing key because you should move element from the middle of deque to its tail.
@InfoBuzz0830
@InfoBuzz0830 2 жыл бұрын
Love it beautiful explanation
@Susjeevs
@Susjeevs 2 жыл бұрын
The insert helper function inserts the node in the middle of the linked list but the # comment says it inserts at the right?
@saladHz
@saladHz 3 ай бұрын
Shouldnt you also delete the node after you check if it already exists? since all the remove() function does it disconnect the nodes to the node itself, however the node itself is still connected to other nodes. It won't be deleted in the capacity check since you already inserted the new node in its place. Correct me if im wrong since im still learning but for c++ the put check condition should like this. if (cache.find(key) != cache.end()) { Node *replace = cache[key]; remove(cache[key]); delete replace; } Effectively detaching any pointers that point to the node to be replaced, and then deleting it.
@atulkumar-bb7vi
@atulkumar-bb7vi Жыл бұрын
Nice Explanation!
@nikhilaradhya4088
@nikhilaradhya4088 Жыл бұрын
In short: 1. Double linked list 2. Cache key: node
@xjlonelystar
@xjlonelystar 2 жыл бұрын
beautiful drawing lol best part of the video
@analisamelojete1966
@analisamelojete1966 9 ай бұрын
I was just asked this today 😂, couldn’t finished it in 10 mins but the guy got the idea of what I was doing. Thought oh this is a great exercise just to find it’s been asked constantly. :/
@analisamelojete1966
@analisamelojete1966 9 ай бұрын
Solved it later using a class attribute called recent. The most right item is always the most recent. Although the complexity is O(n) where n is the class attribute.
@nataliagrigoryeva6615
@nataliagrigoryeva6615 10 ай бұрын
I love NeedCode and use its explanations to create solutions in JavaScript. For this particular problem, it's overcomplicated for JavaScript. There, you will need only the Map data structure (no need for a double-linked list). Just a heads-up for those using JavaScript.
@aishwaryaranghar3385
@aishwaryaranghar3385 2 жыл бұрын
thankYou neetcode!!
@nikhil6842
@nikhil6842 2 жыл бұрын
Your channel is gem
@johnyha9236
@johnyha9236 7 күн бұрын
this question honestly cooked me so hard
@XxRazcxX
@XxRazcxX 6 ай бұрын
Why do you need to have tail pointers? Why not has the left and right nodes point to the real values rather than the (0,0) tails?
@emzx111
@emzx111 3 жыл бұрын
Great video thank u ! Just had a q. Whats the difference here using a linkedlist vs double linked list?
@_XY_
@_XY_ 2 жыл бұрын
Very good explaination 👏👏
@erickmwazonga8871
@erickmwazonga8871 2 жыл бұрын
Awesome videos Neetcode. Do you have a website?
@ziyiyang4550
@ziyiyang4550 2 жыл бұрын
Great video and excellent design! One question though: in put(), if we end up evicting a node and insert a new one, there is no guarantee that the new key is going to map to the same spot as the old one in hash table (if we peek into the array implementation of hash table). So effectively, even if we are within the capacity limit, there could be collision in the hash table, which means some spots are empty and wasted?
@nikhil_a01
@nikhil_a01 2 жыл бұрын
There are always going to be some spots empty in a hash table. If a hash table gets too full the chance of collisions increases hugely. So hash tables resize themselves once they get too full. In Python it resizes when it gets 2/3rds full, and in Java by default it's at 75% full (but it's configurable in Java). In the example from the video, even though we set our LRU cache's capacity to 2, the underlying hash table has whatever capacity Python decides (which is 8 since that's the starting size for any Python dictionary).
@memeproductions4182
@memeproductions4182 2 жыл бұрын
I think this could also be implemented with a circular queue, what do you think?
@TheThickPizza
@TheThickPizza 8 ай бұрын
You can make this a lot more simpler by using an OrderDict from collections: from collections import OrderedDict class LRUCache: def __init__(self, capacity): self.capacity = capacity self.cache = OrderedDict() def get(self, key): val = self.cache.get(key) if val is None: return -1 self.cache.move_to_end(key) return val def put(self, key, value): self.cache[key] = value self.cache.move_to_end(key) if len(self.cache) > self.capacity: _ = self.cache.popitem(last=False) Using `move_to_end` will handle the LRU part for you.
@maryokhin
@maryokhin 5 ай бұрын
I can imagine how you would implement LRU will be an instant follow-up question
@sanjeevrajora7335
@sanjeevrajora7335 2 жыл бұрын
thanx for the explanation
@quirkyquester
@quirkyquester 4 ай бұрын
elegant solution!
@OrphanedZombie
@OrphanedZombie 8 ай бұрын
I was able to do it an inefficient way using a Deque to keep track of the lru lol
@daniyalkabir6527
@daniyalkabir6527 2 жыл бұрын
This is super helpful!
@PinkRosePurpleMauve1
@PinkRosePurpleMauve1 3 жыл бұрын
When I tried to run your solution, there is an error at this line: prev.next, nxt.prev = nxt, prev Error message: AttributeError: 'tuple' object has no attribute 'next' I cannot seem to find the error, and I can't fix it. What do you think could be the cause of this?
@NeetCode
@NeetCode 3 жыл бұрын
Hmm, not sure but I just posted my code on github: github.com/neetcode-gh/leetcode/blob/main/146-LRU-Cache.py Hope it's helpful. Let me know if you figure out the issue.
@TheTrendSupreme
@TheTrendSupreme 2 жыл бұрын
@NeetCode @Vy Nguyen The video is missing a line in insert function where you assign node.next,node.prev=nxt,prev . It is correct in his Git Repo.
@soninirav
@soninirav 2 жыл бұрын
awesome explanation as always... can you please make video on LFU cache too
@daniekpo
@daniekpo 2 жыл бұрын
I tried solving this by myself first but did not use a dummy left and right node. My left and right were null until they pointed to something. That added an extra check and I kept running into different edge cases. I spent a bit of time trying to make it work to show that you can solve the problem without dummy nodes, but I need to move forward now. Did you ever try to solve it with left and right pointing to actual nodes and could potentially by null?
@shashwatshekhar5676
@shashwatshekhar5676 2 жыл бұрын
Would it be recommended to do this problem using OrderedDict in an interview?
@jashangill4089
@jashangill4089 2 жыл бұрын
Got asked on Google, should have watched this earlier :(
@tonyz2203
@tonyz2203 2 жыл бұрын
nice explanation!
@bonle3771
@bonle3771 7 ай бұрын
THIS IS BRUTALLLLLLLLLL
@pcccmn
@pcccmn Жыл бұрын
damn...this question is so hard hahaha
@anushavishwanathan8276
@anushavishwanathan8276 9 ай бұрын
This is GREAT love all your videos. In this case isn't using only one data structure - OrderedDict in Python sufficient? Just coded up a solution on THELEET that beat 80% so was curious could Neet or someone post for me the advantages of using a doubly linked list with a normal hash map?
@leonscander1431
@leonscander1431 6 ай бұрын
I'm not sure, but OrderedDict probably implemented with some kind of tree. And operations on trees are not O(1).
@danielbzhang3280
@danielbzhang3280 Жыл бұрын
Just one quick question: in the get method, if you remove the node "self.remove(self.cache[key])", then how can you insert it to the list again since the node is already removed (self.insertRight(self.cache[key]))
@Mohammed-lo7mf
@Mohammed-lo7mf Жыл бұрын
when you remove it, you're removing it from the linked list, not the cache.
@notlooce
@notlooce 5 ай бұрын
what is the benefit of using left and right dummy nodes here as opposed to just left and right pointers?
@harshit4190
@harshit4190 2 жыл бұрын
Please Explain LFU cache too!
@pranotidesai5084
@pranotidesai5084 2 жыл бұрын
I was preparing for this ques in Nov and why do I feel I saw a different approach of using Orderdict instead. I was looking for LinkedList approach but couldn't find that back in Nov.
@lixujin1698
@lixujin1698 2 жыл бұрын
Can anyone kindly tell me why LRU = self.left.next rather than self.left when it excceds the capacity?
@sujeet4410
@sujeet4410 2 жыл бұрын
left and right are there just to point ... the actual LRU is left.next and most recently used is right.prev ....
@panzach
@panzach Жыл бұрын
@@sujeet4410 Thank you! That confused me too!
@robr4501
@robr4501 2 жыл бұрын
you are a savior !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@somdebdatta9086
@somdebdatta9086 6 ай бұрын
In the insert function, we are inserting the node at the end right? Which means appending. Why are we inserting between the right most element and the second right most element?
@dheepthaaanand3214
@dheepthaaanand3214 3 ай бұрын
When there are no nodes initially, we just have left and right, and so we need to insert between right and right.prev which is left. For upcoming nodes, we again need to insert between right and right.prev which would be the recently added node
@lawrencezhang3899
@lawrencezhang3899 2 жыл бұрын
This solution is awesome
Implement Trie (Prefix Tree) - Leetcode 208
18:56
NeetCode
Рет қаралды 225 М.
L18. Implement LRU Cache
24:56
take U forward
Рет қаралды 83 М.
We Attempted The Impossible 😱
00:54
Topper Guild
Рет қаралды 56 МЛН
VIP ACCESS
00:47
Natan por Aí
Рет қаралды 30 МЛН
Support each other🤝
00:31
ISSEI / いっせい
Рет қаралды 81 МЛН
Enceinte et en Bazard: Les Chroniques du Nettoyage ! 🚽✨
00:21
Two More French
Рет қаралды 42 МЛН
Making an Algorithm Faster
30:08
NeetCodeIO
Рет қаралды 201 М.
How to Implement an LRU Cache (Leetcode #146 explained)
10:32
Byte by Byte
Рет қаралды 37 М.
I Solved 100 LeetCode Problems
13:11
Green Code
Рет қаралды 327 М.
Coding Interviews Be Like
5:31
Nicholas T.
Рет қаралды 6 МЛН
LFU Cache - Leetcode 460 - Python
14:45
NeetCodeIO
Рет қаралды 33 М.
Naming Things in Code
7:25
CodeAesthetic
Рет қаралды 2,3 МЛН
We Attempted The Impossible 😱
00:54
Topper Guild
Рет қаралды 56 МЛН